//
//  MTObject.h
//  MTPPSCRA
//
//  Created by Tam Nguyen on 4/25/16.
//  Copyright © 2016 None. All rights reserved.
//

#import <Foundation/Foundation.h>


@interface CardDataInfo : NSObject

@property(nonatomic) NSString* Track1;
@property(nonatomic) NSString* Track2;
@property(nonatomic) NSString* Track3;
@property(nonatomic) NSString* EncryptedTrack1;
@property(nonatomic) NSString* EncryptedTrack2;
@property(nonatomic) NSString* EncryptedTrack3;
@property(nonatomic) NSString* MagnePrint;
@property(nonatomic) NSString* EncryptedPANExpDate;
@property(nonatomic) NSString* PINPADSerialNumber;
@property(nonatomic) NSString* KSN;
@property(nonatomic) NSString* MagnePrintStatus;
@property(nonatomic) NSString* CBCMAC;
@property(nonatomic) Byte Track1Status;
@property(nonatomic) Byte Track2Status;
@property(nonatomic) Byte Track3Status;
@property(nonatomic) Byte EncryptedTrack1Status;
@property(nonatomic) Byte EncryptedTrack2Status;
@property(nonatomic) Byte EncryptedTrack3Status;
@property(nonatomic) Byte KSNMagnePrintStatus;
@property(nonatomic) Byte EncryptedPANExpDateStatus;
@property(nonatomic) Byte CardType;

//- (void)clearData;
- (NSString*)getTrack1;
- (NSString*)getTrack2;
- (NSString*)getTrack3;
- (NSString*)getTrack1Masked;
- (NSString*)getTrack2Masked;
- (NSString*)getTrack3Masked;
- (NSString*)getMaskedTracks;
- (NSString*)getMagnePrint;
- (Byte)getKSNMagnePrintStatus;
- (Byte)getTrack1DecodeStatus;
- (Byte)getTrack2DecodeStatus;
- (Byte)getTrack3DecodeStatus;
- (NSString*)getLastName;
- (NSString*)getFirstName;
- (NSString*)getMiddleName;
- (NSString*)getName;
- (NSString*)getExpDate;
- (NSString*)getLast4;
- (NSString*)ServiceCode;
- (NSString*)getCardIIN;
- (NSString*)getMaskedPAN;

@end

@interface UserDataEntry : NSObject
@property(nonatomic) Byte status;
@property(nonatomic) NSData* MSRKSN;
@property(nonatomic) NSData* EncryptedUserDataBlock;
@end

@interface USER_ENTRY_DATA : UserDataEntry
@end
@interface MaskedTrackData : NSObject
@property (nonatomic) NSString* name;
@property (nonatomic) NSString* pan;
@property (nonatomic) NSString* expDate;
@property (nonatomic) NSString* scvCode;
@property (nonatomic) NSString* firstName;
@property (nonatomic) NSString* lastName;
@property (nonatomic) NSString* middleName;
@end



@interface PinData : NSObject

    @property (nonatomic) NSString *KSN;
    @property (nonatomic) NSString *EPB;
    @property (nonatomic) NSString *statusCode;

@end

@interface PINDATA : PinData
@end

@interface CARD_DATA_INFO : CardDataInfo
@end

@interface DeviceState : NSObject

@property (nonatomic) Byte deviceState;
@property (nonatomic) Byte sessionState;
@property (nonatomic) Byte deviceStatus;
@property (nonatomic) Byte deviceCertificateStatus;
@property (nonatomic) Byte hardwareStatus;
@property (nonatomic) Byte masterSessionKeyStatus;

@end


@interface DEV_STATE_STATE : NSObject
{
    unsigned char nHWStatus;
    unsigned char nDeviceState;
    unsigned char nSessionState;
    unsigned char nDeviceStatus;
    unsigned char nDevCertStatus;
    unsigned char nSessionKeyStatus;
}

//#pragma mark -
//#pragma mark DEV_STATE_STATE Unsigned Char Properties
//#pragma mark -
//
//@property (nonatomic, readwrite) unsigned char nHWStatus;
//@property (nonatomic, readwrite) unsigned char nDeviceState;
//@property (nonatomic, readwrite) unsigned char nSessionState;
//@property (nonatomic, readwrite) unsigned char nDeviceStatus;
//@property (nonatomic, readwrite) unsigned char nDevCertStatus;
//@property (nonatomic, readwrite) unsigned char nSessionKeyStatus;

#pragma mark -
#pragma mark DEV_STATE_STATE Methods
#pragma mark -

/*
 METHOD         - clearDeviceStateBuffer
 
 PARAMETERS     - N/A
 
 RETURN         - This method returns a NSInteger value (0: SUCCESS, Non-Zero: ERROR)
 
 DESCRIPTION    - This method simply sets all of the unsigned char instance variables to 0
 */
//- (NSInteger)clearDeviceStateBuffer;

@end


@interface MTObject : NSObject

@end
