//
//  AppDelegate.m
//  MTPPSCRASample
//
//  Created by Tam Nguyen on 4/19/16.
//  Copyright © 2016 MagTek. All rights reserved.
//

#import "AppDelegate.h"
#import "emvControllerBLE.h"
#import "emvControllerTCP.h"
#import "emvControllerUART.h"
#import "MTServerListenerViewController.h"
@interface AppDelegate ()

@end

@implementation AppDelegate


- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    // Override point for customization after application launch.
    [[UITabBarItem appearance] setTitleTextAttributes:[NSDictionary dictionaryWithObjectsAndKeys:
                                                       [UIColor grayColor], NSForegroundColorAttributeName,
                                                       [UIFont systemFontOfSize: 13 ],
                                                       NSFontAttributeName,
                                                       nil] forState:UIControlStateNormal];
    [[UITabBarItem appearance] setTitleTextAttributes:[NSDictionary dictionaryWithObjectsAndKeys:
                                                       UIColorFromRGB(0xCC3333), NSForegroundColorAttributeName,
                                                       [UIFont systemFontOfSize: 13 ],
                                                       NSFontAttributeName,
                                                       nil] forState:UIControlStateSelected];
    self.window = [[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]];
    
    //[[UINavigationBar appearance] setBarTintColor:UIColorFromRGB(rgbValue)];
    [[UINavigationBar appearance] setTintColor:UIColorFromRGB(0xcc3333)];
    
    self.window.backgroundColor = [UIColor whiteColor];

    emvControllerBLE *bleVc = [emvControllerBLE new];
    emvControllerTCP * tcpVc = [emvControllerTCP new];
     emvControllerUART * uartVC = [emvControllerUART new];
   // MTServerListenerViewController* serverVC = [MTServerListenerViewController new];

    
    UINavigationController *uartNav = [[UINavigationController alloc] initWithRootViewController:uartVC];
    uartNav.navigationBar.translucent = NO;
    uartNav.tabBarItem = [[UITabBarItem alloc] initWithTitle:@"UART" image:nil tag:1];
    uartNav.tabBarItem.titlePositionAdjustment = UIOffsetMake(0, -16);
    
    UINavigationController *bleNav = [[UINavigationController alloc] initWithRootViewController:bleVc];
    bleNav.navigationBar.translucent = NO;
    bleNav.tabBarItem = [[UITabBarItem alloc] initWithTitle:@"Bluetooth LE" image:nil tag:1];
    bleNav.tabBarItem.titlePositionAdjustment = UIOffsetMake(0, -16);
    
    UINavigationController *tcpNav = [[UINavigationController alloc] initWithRootViewController:tcpVc];
    tcpNav.navigationBar.translucent = NO;
    tcpNav.tabBarItem = [[UITabBarItem alloc] initWithTitle:@"TCP" image:nil tag:1];
    tcpNav.tabBarItem.titlePositionAdjustment = UIOffsetMake(0, -16);
/*
    UINavigationController *serverNav = [[UINavigationController alloc] initWithRootViewController:serverVC];
    serverNav.navigationBar.translucent = NO;
    serverNav.tabBarItem = [[UITabBarItem alloc] initWithTitle:@"TCP Server" image:nil tag:1];
    serverNav.tabBarItem.titlePositionAdjustment = UIOffsetMake(0, -16);
    */
    
    UITabBarController *tabBarController = [UITabBarController new];
    tabBarController.viewControllers = @[uartNav, bleNav, tcpNav/*, serverNav*/];
    tabBarController.tabBar.translucent = NO;
    
    
    // [tabBarController setViewControllers:@[idVc, auVc, dyVC, eVc]];
    
    self.window.rootViewController = tabBarController;
    
    [self.window makeKeyAndVisible];
    
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application {
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application {
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application {
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application {
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application {
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

@end
