//
//  MTDataViewerViewController.m
//  MTSCRADemo
//
//  Created by Tam Nguyen on 7/21/15.
//  Copyright (c) 2015 MagTek. All rights reserved.
//

#import "MTDataViewerViewController.h"
#import "HexUtility.h"
#import "NSObject+TLVParser.h"
#import "MTSigController.h"
#define SHOW_DEBUG_COUNT 0

typedef enum eFunctionKey
{
    FuncKeyLeft   = 0x31,
    FuncKeyMiddle = 0x32,
    FuncKeyRight  = 0x33,
    FuncKeyEnter  = 0x78,
    FuncKeyLeftDP = 0x71,
    FuncKeyRightDP = 0x74
    
} eFunctionKey;



@implementation emvOptionMenu



- (void) createMenu
{
    
    _menuArray = [[NSMutableArray alloc]init];
    [_menuArray addObject:@"Reset Device"];
    [_menuArray addObject:@"Display Message"];
    [_menuArray addObject:@"Request User PIN"];
    [_menuArray addObject:@"Request Card Swipe"];
    [_menuArray addObject:@"Send Special Command"];
    [_menuArray addObject:@"Get Special Command"];
    [_menuArray addObject:@"Request Clear Text User Entry"];
    [_menuArray addObject:@"Request User Selection"];
    [_menuArray addObject:@"Request Device Status"];
    [_menuArray addObject:@"Request Key Information"];
    [_menuArray addObject:@"Request User Data Entry"];
    [_menuArray addObject:@"Request Manual Card Data"];
    [_menuArray addObject:@"Request Device Information"];
    [_menuArray addObject:@"Request Kernel Information"];
    [_menuArray addObject:@"Request Device Configuration"];
    [_menuArray addObject:@"Request Smart Card Transaction"];
    [_menuArray addObject:@"Request SRED Mode"];
    [_menuArray addObject:@"Request Capability String"];
    [_menuArray addObject:@"Request PIN Bypass"];
    [_menuArray addObject:@"Set PAN"];
    [_menuArray addObject:@"Set Amount"];
    [_menuArray addObject:@"Confirm Amount"];
    [_menuArray addObject:@"Get BIN Data"];
    [_menuArray addObject:@"Set BIN Data"];
    [_menuArray addObject:@"Get EMV Tag"];
    [_menuArray addObject:@"Set EMV Tag"];
    [_menuArray addObject:@"Read all CA Public Keys"];
    [_menuArray addObject:@"Request Signature"];
    [_menuArray addObject:@"End Session"];
    
     [_menuArray addObject:@"Request Line Items"];
    [_menuArray addObject:@"Rquest Tip/Cash Back"];
   
    

}
- (void)viewDidLoad {
    [super viewDidLoad];
    [self createMenu];
    [self.tableView registerClass:[UITableViewCell class] forCellReuseIdentifier:@"TableCell"];

}

- (void)viewDidAppear:(BOOL)animated
{
    
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    
    return _menuArray.count;
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"TableCell" forIndexPath:indexPath];
    
    cell.textLabel.text = _menuArray[indexPath.row];
    
    
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    if([self.delegate respondsToSelector:@selector(didSelectMenu:)])
    {
        dispatch_async(dispatch_get_main_queue(), ^{
            [self dismissViewControllerAnimated:YES completion:nil];
        });
        //[_lib stopScanningForPeripherals];
        [[self delegate]didSelectMenu: (int)indexPath.row];
        
        
    }
}


- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}




@end


@interface MTDataViewerViewController ()
{
    int swipeCount;
    NSString* commandResult;
    BOOL isQuickDip;
}
@end

@implementation MTDataViewerViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    [self setUpUI];
    // Do any additional setup after loading the view.
    
    
    
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(void)didEnterBackground
{
}

- (BOOL)isX
{
    if([[UIDevice currentDevice]userInterfaceIdiom]==UIUserInterfaceIdiomPhone) {
        if (@available(iOS 8, *)) {
            NSLog(@"%i",(int)[[UIScreen mainScreen] nativeBounds].size.height);
            switch ((int)[[UIScreen mainScreen] nativeBounds].size.height) {
                    
                case 1136:
                    printf("iPhone 5 or 5S or 5C");
                    break;
                case 1334:
                    printf("iPhone 6/6S/7/8");
                    break;
                case 2208:
                    printf("iPhone 6+/6S+/7+/8+");
                    break;
                case 2436:
                case 2688:
                case 1792:
                    return YES;
                    break;
                default:
                    printf("unknown");
            }
        }
        else
            return NO;
    }
    else
    {
        
        NSLog(@"%i",(int)[[UIScreen mainScreen] nativeBounds].size.height);
        switch ((int)[[UIScreen mainScreen] nativeBounds].size.height) {
                
                
            case 2388:
            case 2732:
                //iPad Pro 11
                return YES;
            default:
                return NO;
                
                
        }
        
    }
    return NO;
    
}

- (void) setUpUI
{
    int xOffset = 0;
    if([self isX])
    {
        xOffset = 70;
    }
    self.navigationItem.rightBarButtonItem = [[UIBarButtonItem alloc] initWithTitle:@"Clear Data"
                                                                              style:UIBarButtonItemStylePlain
                                                                             target:self action:@selector(clearData)];
    
    _btnConnect = [[UIButton alloc]initWithFrame:CGRectMake(0, self.view.frame.size.height - 98 - 65  - xOffset, self.view.frame.size.width, 50)];
    [_btnConnect setTitle:@"Connect" forState:UIControlStateNormal];
    [_btnConnect setBackgroundColor:UIColorFromRGB(0x3465AA)];
    // [_btnConnect addTarget:self action:@selector(connect) forControlEvents:UIControlEventTouchUpInside];
    
    
    _txtData = [[UITextView alloc]initWithFrame:CGRectMake(5, 60, self.view.frame.size.width - 10, self.view.frame.size.height - 240)];
    _txtData.backgroundColor = UIColorFromRGB(0x667788);
    _txtData.textColor = UIColorFromRGB(0xffffff);
    _txtData.delegate = self;
    [_txtData setEditable:NO];
    
    _txtCommand = [[UITextField alloc]initWithFrame:CGRectMake(5 , 9, self.view.frame.size.width - 90, 40)];
    _txtCommand.delegate = self;
    _txtCommand.backgroundColor = UIColorFromRGB(0xdddddd);
    _txtCommand.placeholder = @"Send Command";
    
    
    _txtCommand.text = @""; // Extended Command ECHO
    
    
    _btnSendCommand =  [[UIButton alloc]initWithFrame:CGRectMake(_txtCommand.frame.origin.x + _txtCommand.frame.size.width + 5 , 9, 75, 40)];
    [_btnSendCommand setTitle:@"Send" forState:UIControlStateNormal];
    [_btnSendCommand addTarget:self action:@selector(sendCommand) forControlEvents:UIControlEventTouchUpInside];
    [_btnSendCommand setBackgroundColor:UIColorFromRGB(0x3465AA)];
    
    [self.view addSubview:_txtCommand];
    [self.view addSubview:_txtData];
    [self.view addSubview:_btnSendCommand];
    
    [self.view addSubview:_btnConnect];
    
    [self setText: [NSString stringWithFormat:@"App Version: %@.%@ , SDK Version: %@", [[[NSBundle mainBundle] infoDictionary] objectForKey:@"CFBundleShortVersionString"], [[[NSBundle mainBundle] infoDictionary] objectForKey:@"CFBundleVersion"],   [[MTPPSCRA sharedInstance] getSDKVersion]]];
    
    
    self.txtData.frame = CGRectMake(5, 60, self.view.frame.size.width - 10, self.view.frame.size.height - 330  - xOffset);
    
    int btnWidth = self.view.frame.size.width / 3;
    
    _msr = [self createRadioButtonWithFrame:CGRectMake(5, self.view.frame.size.height - 98 - 65 - 115  - xOffset, 80, 60 ) Title:@"MSR" Color:UIColorFromRGB(0x3465AA)];
    _chip = [self createRadioButtonWithFrame:CGRectMake(btnWidth - 50, self.view.frame.size.height - 98 - 65 - 115  - xOffset, 80, 60 ) Title:@"Chip" Color:UIColorFromRGB(0x3465AA)];
    _contactless = [self createRadioButtonWithFrame:CGRectMake((btnWidth * 2) - 110, self.view.frame.size.height - 98 - 65 - 115  - xOffset, 120, 60 ) Title:@"Contactless" Color:UIColorFromRGB(0x3465AA)];
    _quickChip = [self createRadioButtonWithFrame:CGRectMake((btnWidth * 3) - 115, self.view.frame.size.height - 98 - 65 - 115  - xOffset, 120, 60 ) Title:@"Quick Chip" Color:UIColorFromRGB(0x3465AA)];
    
    [_quickChip setSelected: NO];
    
    _btnStartEMV = [[UIButton alloc]initWithFrame:CGRectMake(5, self.view.frame.size.height - 98 - 65 - 60  - xOffset, btnWidth - 7, 40 )];
    [_btnStartEMV setTitle:@"Start" forState:UIControlStateNormal];
    [_btnStartEMV setBackgroundColor:UIColorFromRGB(0x3465AA)];
    [_btnStartEMV addTarget:self action:@selector(startEMV) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:_btnStartEMV];
    
    _btnCancel = [[UIButton alloc]initWithFrame:CGRectMake(btnWidth, self.view.frame.size.height - 98 - 65 - 60 - xOffset, btnWidth - 2, 40)];
    [_btnCancel setTitle:@"Cancel" forState:UIControlStateNormal];
    [_btnCancel setBackgroundColor:UIColorFromRGB(0xCC3333)];
    [_btnCancel addTarget:self action:@selector(cancelEMV) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:_btnCancel];
    
    
    _endSession = [[UIButton alloc]initWithFrame:CGRectMake((btnWidth * 2), self.view.frame.size.height - 98 - 65 - 60 - xOffset, btnWidth - 4, 40)];
    [_endSession setTitle:@"End Session" forState:UIControlStateNormal];
    [_endSession setBackgroundColor:UIColorFromRGB(0xCC3333)];
    [_endSession addTarget:self action:@selector(endSessionSelected) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:_endSession];
    
    
    
}

- (MTCustomRadio *)createRadioButtonWithFrame:(CGRect) frame Title:(NSString *)title Color:(UIColor *)color
{
    MTCustomRadio *radioButton = [[MTCustomRadio alloc] initWithFrame:frame];
    radioButton.iconSquare = YES;
    radioButton.multipleSelectionEnabled = YES;
    [radioButton setSelected:YES];
    radioButton.titleLabel.font = [UIFont systemFontOfSize:18];
    [radioButton setTitle:title forState:UIControlStateNormal];
    [radioButton setTitleColor:color forState:UIControlStateNormal];
    radioButton.iconColor = color;
    radioButton.indicatorColor = color;
    radioButton.contentHorizontalAlignment = UIControlContentHorizontalAlignmentLeft;
   // [radioButton addTarget:self action:@selector(logSelectedButton:) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:radioButton];
    
    return radioButton;
}

- (void)sendCommand
{
    NSData* commandData = [HexUtility getBytesFromHexString:self.txtCommand.text];
    [[MTPPSCRA sharedInstance] sendSpecialCommand:commandData];
}

- (void) textViewDidEndEditing:(UITextView *)textView
{
    [self scrollTextViewToBottom:textView];
}
- (void)textViewDidChange:(UITextView *)textView
{
    
    
    [self scrollTextViewToBottom:self.txtData];

}
-(void)scrollTextViewToBottom:(UITextView *)textView {
    if(textView.text.length > 0 ) {
        NSRange bottom = NSMakeRange(textView.text.length -1, 1);
        [textView scrollRangeToVisible:bottom];
    }
    
}
- (void)clearData
{
    self.txtData.text = @"";
}
- (void)startEMV
{
    emvOptionMenu* popoverContent = [[emvOptionMenu alloc] init];
    popoverContent.delegate = self;
    [self.navigationController pushViewController:popoverContent animated:YES];
}


- (void) onConnectionStateChanged:(ConnectionType)connectionType state:(ConnectionState)state
{
    NSString* stateText;
    if(state == Connected)
    {
        stateText = @"Connected";
    }
    else if (state == Connecting)
    {
        stateText = @"Connecting";
    }
    else if (state == Disconnected)
    {
        stateText = @"Disconnected";
    }
    else if (state == Error || state == Unreachable)
    {
        stateText = @"Failed to reach device";
    }
    else if (state == Listening)
    {
        stateText = @"Server Listening...";
    }
    else
    {
        stateText = @"Disconnecting";
    }
    dispatch_async(dispatch_get_main_queue(), ^{
        
        
        [self setText: stateText];
        
        if(state == Connected)
        {
            [_btnConnect setTitle:@"Disconnect" forState:UIControlStateNormal];
            [self.btnConnect setBackgroundColor:UIColorFromRGB(0xcc3333)];
        }
        else if(state == Listening)
        {
            [_btnConnect setTitle:@"Stop Listening" forState:UIControlStateNormal];
            [self.btnConnect setBackgroundColor:UIColorFromRGB(0xcc3333)];
        }
        else
        {
            [_btnConnect setTitle: @"Connect" forState:UIControlStateNormal];
            [self.btnConnect setBackgroundColor:UIColorFromRGB(0x3465AA)];
            
        }
    });
    
}

- (void) setText:(NSString*)text
{
    dispatch_async(dispatch_get_main_queue(), ^{
        self.txtData.text = [NSString stringWithFormat:@"%@\r%@", self.txtData.text, text];
        [self scrollTextViewToBottom:self.txtData];
    });
}

- (void) cancelEMV
{
    [[MTPPSCRA sharedInstance] cancelOperation];
}
- (void)endSessionSelected
{
     [[MTPPSCRA sharedInstance]endSession:0];
}
- (void)didSelectMenu:(int)index
{
    [self.navigationController popViewControllerAnimated:YES];
    
    switch(index)
    {
        case 0:
            [self resetDeviceSelected];
            break;
        case 1:
            [self displayMessageSelected];
            break;
        case 2:
            [self requestPINSelected];
            break;
        case 3:
            [self requestCardSelected];
            break;
        case 4:
            [self sendSpecialCommand];
            break;
        case 5:
            [self getSpecialCommand];
            break;
        case 6:
            [self requestClearTextEntry];
            // [self requestUserSelectionSelected];
            break;
        case 7:
            [self requestUserSelectionSelected];
            // [self requestDeviceStatusSelected];
            break;
        case 8:
            [self requestDeviceStatusSelected];
            //[self requestKeyInformationSelected];
            break;
        case 9:
            [self requestKeyInformationSelected];
            //[self requestUserDataEntrySelected];
            break;
        case 10:
            [self requestUserDataEntrySelected];
            //[self requestManualCardDataEntrySelected];
            break;
        case 11:
            [self requestManualCardDataEntrySelected];
            // [self requestDeviceInformationSelected];
            break;
            
        case 12:
            [self requestDeviceInformationSelected];
            //[self requestKernelInformationSelected];
            break;
        case 13:
            [self requestKernelInformationSelected];
            //[self requestDeviceConfigurationSelected];
            break;
        case 14:
            [self requestDeviceConfigurationSelected];
            //[self requestSmartCardTransactionSelected];
            break;
        case 15:
            [self requestSmartCardTransactionSelected];
            //[self requestSREDModeSelected];
            break;
        case 16:
            [self requestSREDModeSelected];
            //[self requestCapabilityStringSelected];
            
            break;
            
        case 17:
            [self requestCapabilityStringSelected];
            //[self requestSetPAN];
            
            break;
        case 18:
            [self requestPINBypass];
            break;
        case 19:
            [self requestSetPAN];
            //[self requestSetAmountSelected];
            
            break;
            
        case 20:
            [self requestSetAmountSelected];
            //[self requestConfirmAmountSelected];
            
            break;
            
        case 21:
            [self requestConfirmAmountSelected];
            // Get BIN Data Case
            //[self requestGetBINDataSelected];
            
            break;
            
        case 22:
            [self requestGetBINDataSelected];
            // Set BIN Data Case
            //[self requestSetBINDataSelected];
            
            break;
            
            
        case 23:
            [self requestSetBINDataSelected];
            
            
            break;
            
        case 24:
            [self getEMVTagSelected];
            
            
            break;
            
        case 25:
            [self setEMVTagSelected];
            
            break;
        case 26:
            [self readAllCAPublicKeysSelected];
            break;
        case 27:
            [self requestUserSignature];
            
            break;
        case 28:
            
            [[MTPPSCRA sharedInstance]endSession:0];
            break;
        case 29:
            
            [self requestSendLineItems];
            break;
        case 30:
            [self requestCashBackOrTip];
            break;
           
        default:
            break;
    }
    
}

-(void)requestCashBackOrTip
{
    Byte amount[]             = {0x00, 0x00, 0x00, 0x1, 0x00, 0x00};
    Byte taxAmount[]             = {0x00, 0x00, 0x00, 0x00, 0x10, 0x00};
    Byte taxRate[]             = {0x10, 0x00, 0x00};
    
    Byte reserve[26] = {0};
    
    [[MTPPSCRA sharedInstance]  requestTipOrCashback:0x3c mode:0x01 tone:0x01 amount:amount taxAmount:taxAmount taxRate:taxRate tipMode:0x00 option1:0x01 option2:0x02 option3:0x03 reserved:reserve];
    
}


-(void)requestSendLineItems
{
    NSArray* menuItems = @[ @"Tab 1", @"Tab 2", @"Tab 3", @"Tab 4", @"Tab 5",@"Tab 6",@"Tab 7", @"Tab 8",@"Tab 9", @"Tab 10"];
    NSMutableData* menuData = [[NSMutableData alloc] init];
    Byte cr[1] = {(Byte)0x0d};
    for(NSString* item in menuItems)
    {
        //NSData* itemData = [HexUtility getBytesFromHexString:item];
        [menuData appendBytes:[item UTF8String] length:item.length];
        [menuData appendBytes:cr length:1];
        
    }
    
    [menuData appendBytes:cr length:1];
    [[MTPPSCRA sharedInstance] sendBigBlockData:0x16 dataBlock:menuData completion:^{
        [[MTPPSCRA sharedInstance] getSelectedMenuItem:0x3c mode:0x00 tone:0x01];
    }];
}

- (void)requestUserSignature
{
    [[MTPPSCRA sharedInstance]requestSignature:0x3c beepTones:0x01 options:0x00];
}
- (void)readAllCAPublicKeysSelected
{
   // NSString* data = @"001FF91DDFDF550102DFDF250898D995240E190A0EFA0ADFDF3F06000000000000000000000000006E01D255";
    //
    [[MTPPSCRA sharedInstance] setCAPublicKey:0x0f keyBlock:0x00];
}


- (void)setEMVTagSelected
{
    NSString *tlvBlobString = @"DFDF140400000BB9";
    int tlvBlobLen = (int)tlvBlobString.length / 2;
    int messageLengthLocal     = 0;
    int zeroPaddingBytes  = 0;
    
    if(((tlvBlobLen + 27) % 8) > 0)
    {
        zeroPaddingBytes = 8 - ((tlvBlobLen + 27) % 8);
    }
    
    messageLengthLocal = tlvBlobLen + 27 + zeroPaddingBytes;
    
    
    unsigned char *message = (unsigned char *)malloc(messageLengthLocal);
    
    memset(message, 0x01, messageLengthLocal);
    
    
    unsigned char byte1 = (unsigned char)((tlvBlobLen + 25 & 0x0000FF00) >> 8);
    unsigned char byte2 = (unsigned char)( tlvBlobLen + 25 & 0x000000FF);
    
    Byte lengthOne = (unsigned char)(tlvBlobLen + 21);
    Byte  lengthTwo = (unsigned char) tlvBlobLen;
    
    message[0]  = byte1;
    message[1]  = byte2;
    message[2]  = 0xF9;
    message[3]  = 0x82;
    message[4]  = (unsigned char)((lengthOne >> 8) & 0xFF);
    message[5]  = (unsigned char)( lengthOne       & 0xFF);
    
    message[6]  = 0xDF;
    message[7]  = 0xDF;
    message[8]  = 0x55;
    message[9]  = 0x01;
    message[10] = 0x02;
    
    message[11] = 0xDF;
    message[12] = 0xDF;
    message[13] = 0x25;
    message[14] = 0x08;
    Byte devSn[8] = {0};
    int deviceSerialNumberLen = 8;

    NSString* devSNString;
   // [[MTPPSCRA sharedInstance]requestDeviceInformation:0x05 information:&devSNString];
    [[HexUtility getBytesFromHexString:devSNString]getBytes:devSn length:devSNString.length];
    
    
    memcpy(&message[15], devSn, deviceSerialNumberLen);
    message[15 + deviceSerialNumberLen] = 0xFA;
    
    message[15 + deviceSerialNumberLen + 1] = 0x82;
    message[15 + deviceSerialNumberLen + 2] = (Byte)((lengthTwo >> 8) & 0xFF);
    message[15 + deviceSerialNumberLen + 3] = (Byte)(lengthTwo & 0xFF);
    
    Byte tlvData[tlvBlobString.length / 2];
    [[HexUtility getBytesFromHexString:tlvBlobString]getBytes:tlvData length:tlvBlobString.length / 2];
    
    memcpy(&message[15 + deviceSerialNumberLen + 4], tlvData, tlvBlobLen);
    NSMutableData* finalData = [NSMutableData dataWithBytes:message length:messageLengthLocal];
    free(message);
    NSString* mac =  @"00000000";
    [finalData appendData:[HexUtility getBytesFromHexString:[mac substringToIndex:8]]];
    
    unsigned char tagType         = 0x00;
    unsigned char operation       = 0x01; // 0xFF to Restore to Default Settings
    unsigned char database        = 0x00;
    
    
    
    
    [[MTPPSCRA sharedInstance] requestSetEMVTag:tagType tagOperation:operation inputTLVData:finalData dataBase:database option:0x00 reserved:nil];
    
}

- (void)getEMVTagSelected{
    
    
    unsigned char tagType         = 0x00;
    unsigned char operation       = 0x0F;
    unsigned char dataBase        = 0x00;
    
    
    [[MTPPSCRA sharedInstance]requestGetEMVTag:tagType tagOperation:operation inputTLVData:nil dataBase:dataBase option:0x00 reserved:nil ];
    
  
}
- (void)requestSetBINDataSelected
{
    NSString *tlvDataString = @"DFDF6106333038363136"
    "DFDF6206363033363238"
    "DFDF6306000000000000"
    "DFDF6406000000000000"
    "DFDF6506000000000000"
    "DFDF6606000000000000";
    int tlvDataLength = (int)tlvDataString.length / 2;
    int messageLengthLocal     = 0;
    int zeroPaddingBytes  = 0;
    
    if(((tlvDataLength + 27) % 8) > 0)
    {
        zeroPaddingBytes = 8 - ((tlvDataLength + 27) % 8);
    }
    
    messageLengthLocal = tlvDataLength + 27 + zeroPaddingBytes;
    
    
    unsigned char *message = (unsigned char *)malloc(messageLengthLocal);
    
    memset(message, 0x01, messageLengthLocal);
    
    
    unsigned char byte1 = (unsigned char)((tlvDataLength + 25 & 0x0000FF00) >> 8);
    unsigned char byte2 = (unsigned char)( tlvDataLength + 25 & 0x000000FF);
    
    int lengthOne = (unsigned char)(tlvDataLength + 21);
    int  lengthTwo        = (unsigned char) tlvDataLength;
    
    message[0]  = byte1;
    message[1]  = byte2;
    message[2]  = 0xF9;
    message[3]  = 0x82;
    message[4]  = (unsigned char)((lengthOne >> 8) & 0xFF);
    message[5]  = (unsigned char)( lengthOne       & 0xFF);
    
    message[6]  = 0xDF;
    message[7]  = 0xDF;
    message[8]  = 0x55;
    message[9]  = 0x01;
    message[10] = 0x02;
    
    message[11] = 0xDF;
    message[12] = 0xDF;
    message[13] = 0x25;
    message[14] = 0x08;
    Byte devSn[8] = {0};
    int deviceSerialNumberLength = 8;
    NSString* devSNString = [[MTPPSCRA sharedInstance]getDeviceSerial];
    [[HexUtility getBytesFromHexString:devSNString]getBytes:devSn length:devSNString.length];
    memcpy(&message[15], devSn, deviceSerialNumberLength);
    message[15 + deviceSerialNumberLength] = 0xFA;
    
    message[15 + deviceSerialNumberLength + 1] = 0x82;
    message[15 + deviceSerialNumberLength + 2] = (Byte)((lengthTwo >> 8) & 0xFF);
    message[15 + deviceSerialNumberLength + 3] = (Byte)(lengthTwo & 0xFF);
    Byte tlvData[tlvDataString.length / 2];
    [[HexUtility getBytesFromHexString:tlvDataString]getBytes:tlvData length:tlvDataString.length / 2];
    memcpy(&message[15 + deviceSerialNumberLength + 4], tlvData, tlvDataLength);
    NSMutableData* finalData = [NSMutableData dataWithBytes:message length:messageLengthLocal];
    free(message);
    
    NSString* mac =  @"00000000";
    [finalData appendData:[HexUtility getBytesFromHexString:[mac substringToIndex:8]]];
    [[MTPPSCRA sharedInstance] setBINTableData:finalData];
    ////neeed to complete
    
}
- (void)requestGetBINDataSelected
{
    [[MTPPSCRA sharedInstance]requestBINTableData];
}
- (void)requestConfirmAmountSelected
{
    [[MTPPSCRA sharedInstance] confirmAmount:0x3c beepTones:0x01];
}
- (void)requestSetAmountSelected
{
    [[MTPPSCRA sharedInstance]setAmount:@"9,999.99"];
}
- (void)requestPINBypass
{
    [[MTPPSCRA sharedInstance]requestPINBypass];
}
- (void)requestSetPAN
{
    [[MTPPSCRA sharedInstance]setPAN:@"1234567890123456"];
}
- (void)requestCapabilityStringSelected
{
    [[MTPPSCRA sharedInstance]requestDeviceInformation:0x02];
}

- (void)displayMessageSelected
{
    [[MTPPSCRA sharedInstance]setDisplayMessage:0x03 messageID:DISPLAY_MESSAGE_THANK_YOU];
    
}
- (void)requestCardSelected
{
    [[MTPPSCRA sharedInstance]requestCard:0x3c messageID:0x01 beepTones:0x01];
    
}
- (void)requestPINSelected
{
    [[MTPPSCRA sharedInstance]requestPIN:0xff pinMode:0x00 maxPINLength:0x06 minPINLength:0x04 beepTones:0x01 option:0x00];
}
- (void)requestSREDModeSelected
{
    BOOL sred = [[MTPPSCRA sharedInstance]isDeviceSRED];
    if(sred)
    {
        [self setText: @"This device support SRED"];
    }
    else
    {
         [self setText: @"This device DO NOT support SRED"];
    }
}

- (void)resetDeviceSelected
{
    [[MTPPSCRA sharedInstance]deviceReset];
}

- (void)sendSpecialCommand
{
    Byte sampleByte[] = {0x1a, 0x05}; //get device information (set)
    //Byte sampleByte[] = {0x02, 0x00};
    [[MTPPSCRA sharedInstance]sendSpecialCommand:[NSData dataWithBytes:&sampleByte length:2]];
}

- (void)getSpecialCommand
{
    Byte sampleByte[] = {0x1a, 0x05}; //get device information (get)
    //Byte sampleByte[] = {0x02, 0x00};
    [[MTPPSCRA sharedInstance]getSpecialCommand:[NSData dataWithBytes:&sampleByte length:2]];
}

- (void)requestClearTextEntry
{
    [[MTPPSCRA sharedInstance]requestClearTextUserDataEntry:0x3c messageID:0x00 beepTones:0x01];
}
- (void)requestDeviceInformationSelected
{
    [[MTPPSCRA sharedInstance]requestDeviceInformation:0x06];
}
/*
- (void)requestDeviceInformationSyncSelected
{
    NSString* infoOut = @"";
    int i = [[MTPPSCRA sharedInstance]requestDeviceInformation:0x05 information:&infoOut];
    if(i == 0)
        self.txtData.text = [NSString stringWithFormat:
                             @"%@\r\nType: %02x"
                             "\r\nData: %@",
                             self.txtData.text,
                             0x05,
                             infoOut
                             ];
    
}
*/
- (void)requestUserSelectionSelected
{
    [[MTPPSCRA sharedInstance]requestResponse:0x3c selectMsg:0x02 keyMask:0x0f beepTones:0x01];
}
- (void)requestDeviceStatusSelected
{
    [[MTPPSCRA sharedInstance]requestDeviceStatus];
}

- (void)requestKeyInformationSelected
{
    [[MTPPSCRA sharedInstance]requestKeyInformation:0x02];
}

- (void)requestUserDataEntrySelected
{
    [[MTPPSCRA sharedInstance]requestUserDataEntry:0x3c messageID:0x00 beepTones:0x01];
    
}

- (void)requestManualCardDataEntrySelected
{
    [[MTPPSCRA sharedInstance]requestManualCardData:0x3c beepTones:0x01 options:0x08];
}

- (void)requestKernelInformationSelected
{
    [[MTPPSCRA sharedInstance]requestKernelInformation:0x01];
}

- (void)requestDeviceConfigurationSelected
{
    [[MTPPSCRA sharedInstance]requestDeviceConfiguration];
}

- (Byte)getCardType
{
    Byte cardType = 0x00;
    Byte msr = 0x01;
    Byte chip= 0x02;
    Byte contactless = 0x04;
    
    if([_msr isSelected])
    {
        cardType |= msr;
    }
    if([_chip isSelected])
    {
        cardType |= chip;
    }
    if([_contactless isSelected])
    {
        cardType |= contactless;
    }
    
    return cardType;
}

- (void)requestSmartCardTransactionSelected
{
    Byte cardType             = [self getCardType];//0x01 | 0x02 | 0x04;//= 0x07;  // Card Type 3 will arm both the MSR reader and the ICC reader
    Byte confirmationWaitTime = 0x30;
    Byte PINWaitTime          = 0x30;
    Byte tone                 = 0x00;
    Byte option               = 0x00;
    Byte amount[]             = {0x00, 0x00, 0x00, 0x00, 0x00, 0x01};
    Byte transactionType      = 0x08;
    Byte cashBack[]           = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
    Byte reservedBytes[43]    = {0};
    
    
   
    Byte currencyCode[2] = {0x08, (Byte)0x40};
    Byte chipMode = 0x00;
    if(_quickChip.isSelected)
    {
        chipMode = 0x01;
        isQuickDip = YES;
    }
    else
    {
        chipMode = 0x00;
        isQuickDip = NO;
    }
    
    reservedBytes[15] = chipMode;
    reservedBytes[12] = currencyCode[0];
    reservedBytes[13] = currencyCode[1];
    
    
    NSData* reserveData = [NSData dataWithBytes:&reservedBytes length:sizeof(reservedBytes)];
    [[MTPPSCRA sharedInstance]requestSmartCard:cardType confirmationWaitTime:confirmationWaitTime pinEnteringTime:PINWaitTime beepTones:tone option:option amount:amount transactionType:transactionType cashBack:cashBack reserved:reserveData];
    //[[MTPPSCRA sharedInstance]requestSmartCard:cardType confirmationWaitTime:confirmationWaitTime pinEnteringTime:PINWaitTime beepTones:tone option:option amount:amount transactionType:transactionType cashback:cashBack reserved:reservedBytes];
}
/*----------------------------------------------------*/
#pragma mark - SDK Delegate Section -
/*----------------------------------------------------*/

- (void)onDataReadyCompleteEvent:(NSData *)data
{
        [self setText:  [NSString stringWithFormat:@"\n[Get Special Command Data]\n%@", [HexUtility toHex:data]]];
}
- (void)deviceMessageCAPublicKey:(NSData *)keyData
{
    NSMutableDictionary* tlv = [keyData parseTLVData];
    
    
    
    dispatch_async(dispatch_get_main_queue(), ^{
        
         [self setText:  [NSString stringWithFormat:@"\n[Public Key Data]\n%@", [tlv dumpTags]]];
    });
    
}

- (void)deviceMessageEMVTags:(NSData *)tagData
{
    
    NSMutableDictionary* tlv = [tagData parseTLVData];
    
    
    
    dispatch_async(dispatch_get_main_queue(), ^{
        
        [self setText:[NSString stringWithFormat:@"\n[EMV Tags]\n%@", [tlv dumpTags]]];
    });
    
}



- (void)deviceMessageTipOrCashback:(Byte)status mode:(Byte)mode amount:(Byte *)amount tax:(Byte *)tax taxRate:(Byte *)taxRate tipOrCashBack:(Byte *)tipOrCashBack reserve:(Byte)reserve
{
    
    NSString* amountStr = [HexUtility toHex:[NSData dataWithBytes:amount length:6]];
    NSString* taxStr = [HexUtility toHex:[NSData dataWithBytes:tax length:6]];
    NSString* taxRateStr = [HexUtility toHex:[NSData dataWithBytes:taxRate length:3]];
    NSString* tipOrCashBackStr = [HexUtility toHex:[NSData dataWithBytes:tipOrCashBack length:6]];
    
    
     [self setText:  [NSString stringWithFormat:
                                              @"\r\nTip or Cashback Status: %02x\r\n"
                                              "Mode: %02x\r\n"
                                              "Amount: %@\r\n"
                                              "Tax: %@\r\n"
                                              "Tax Rate: %@\r\n"
                                              "Tip/CashBack Amount: %@\r\n",
                                              status,
                                              mode,
                                              amountStr,
                                              taxStr,
                                              taxRateStr,
                                              tipOrCashBackStr
                                              ]];
}

- (void)deviceMessageSelectedMenuItem:(Byte)status mode:(Byte)mode index:(Byte)index reserve:(Byte)reserve
{
    
    
    [self setText:  [NSString stringWithFormat:
                                              @"\r\nSelected Status: %02x\r\n"
                                              "Mode: %02x\r\n"
                                              "Index Selected: %02x\r\n",
                                              status,
                                              mode,
                                              index
                                              ]];
}


- (void)deviceMessageBINTableData:(NSData *)binData
{
     [self setText:  [NSString stringWithFormat:
                         @"BIN Table Data: %@",
                         binData
                         ]];
}

- (void)deviceMessageDeviceInformation:(Byte)type data:(NSData *)data
{
     [self setText:  [NSString stringWithFormat:
                         @"Type: %02x"
                         "\r\nData: %@",
                         type,
                         [[NSString alloc] initWithData:data encoding:NSNonLossyASCIIStringEncoding]
                         ]];
    
}
- (void)deviceMessageCardStatus:(Byte)operationStatus cardStatus:(Byte)cardStatus
{
     [self setText:  [NSString stringWithFormat:
                         @"Operation Status: %02x"
                         "\r\nCard Status: %02x",
                         operationStatus,
                         cardStatus
                         ]];
}

- (void)deviceMessagePinData:(Byte)operationsStatus pinData:(PinData *)pinData
{
     [self setText: [NSString stringWithFormat:
                         @"Operation Status: %02x"
                         "\r\nPIN Status: %@"
                         "\r\nPIN KSN: %@"
                         "\r\nPIN EPB: %@",
                         operationsStatus,
                         pinData.statusCode,
                         pinData.KSN,
                         pinData.EPB
                         ]];
}
- (void)deviceDataAvailable
{
     [self setText:@"Card data available"];
    
}
- (void) deviceMessageUserSignature:(Byte)status signature:(NSData*)signature
{

    [self setText:  [NSString stringWithFormat:
                         @"User Signature %@",
                         signature
                         ]];
    if(status == 0x00)
    {
//    MTSigController* sig = [[MTSigController alloc]initWithSignature:signature];
//    [self.navigationController pushViewController:sig animated:YES];
 //dispatch_async(dispatch_get_main_queue(), ^{
    MTSigController* sigCon = [[MTSigController alloc]initWithSignature:[signature copy]];
   
        [self.navigationController pushViewController:sigCon animated:YES];
    }
   // });
}
- (void)deviceMessageDataChanged
{
    CardDataInfo* cardData = [[MTPPSCRA sharedInstance] getCardDataInfo];
     [self setText:  [NSString stringWithFormat:
                        @"Track 1: %@\r\n"
                        "Track 2: %@\r\n"
                        "Track 3: %@\r\n"
                        "Card Type: %02x\r\n"
                        "Encrypted Track 1: %@\r\n"
                        "Encrypted Track 2: %@\r\n"
                        "Encrypted Track 3: %@\r\n"
                        "Encrypted MagnePrint: %@\r\n"
                        "Encrypted Pan & Exp Date: %@\r\n"
                        "Serial Number: %@\r\n"
                        "KSN: %@\r\n"
                        "MagnePrint Status: %@\r\n"
                        "CBC MAC: %@\r\n"
                        "Track 1 Status: %hhu\r\n"
                        "Track 2 Status: %hhu\r\n"
                        "Track 3 Status: %hhu\r\n"
                        "Encrypted Track 1 Status: %hhu\r\n"
                        "Encrypted Track 2 Status: %hhu\r\n"
                        "Encrypted Track 3 Status: %hhu\r\n"
                        "KSN MagnePrint Status: %hhu\r\n"
                        "Encrypted PAN & Exp Date Status: %hhu\r\n"
                        "First Name: %@ \r\n"
                        "Last Name: %@ \r\n"
                        "Middle: %@ \r\n"
                        "Expiration Date: %@ \r\n"
                        "Card Last 4: %@ \r\n"
                        "Card IIN : %@ \r\n"
                        "Card Masked PAN : %@ \r\n",
                        cardData.Track1,
                        cardData.Track2,
                        cardData.Track3,
                        cardData.CardType,
                        cardData.EncryptedTrack1,
                        cardData.EncryptedTrack2,
                        cardData.EncryptedTrack3,
                        cardData.MagnePrint,
                        cardData.EncryptedPANExpDate,
                        cardData.PINPADSerialNumber,
                        cardData.KSN,
                        cardData.MagnePrintStatus,
                        cardData.CBCMAC,
                        cardData.Track1Status,
                        cardData.Track2Status,
                        cardData.Track3Status,
                        cardData.EncryptedTrack1Status,
                        cardData.EncryptedTrack2Status,
                        cardData.EncryptedTrack3Status,
                        cardData.KSNMagnePrintStatus,
                        cardData.EncryptedPANExpDateStatus,
                        cardData.getFirstName,
                        cardData.getLastName,
                        cardData.getMiddleName,
                        cardData.getExpDate,
                        cardData.getLast4,
                        cardData.getCardIIN,
                        cardData.getMaskedPAN
                        ]];
    
}
- (void)deviceMessageACKStatus:(Byte)status commandID:(Byte)commandID
{
    [self setText: [NSString stringWithFormat:
                         @"Status: %02x\r\n"
                         "Command ID: %02x\r\n",
                         status,
                         commandID
                         ]];
}
- (void)deviceMessageDisplayMessageDone:(Byte)operationStatus
{
    [self setText:  [NSString stringWithFormat:
                         @"Display Message Status:%02x\r\n",
                         operationStatus
                         ]];
    
}

- (void)deviceMessageUserSelection:(Byte)operationStatus keyValue:(Byte)keyValue
{
     [self setText:  [NSString stringWithFormat:
                         @"User Selection Status:%02x\r\n"
                         @"Key Pressed: %02x",
                         operationStatus,
                         keyValue
                         ]];
}
- (void)deviceMessageDeviceStatus:(DeviceState *)deviceStatus
{
     [self setText:  [NSString stringWithFormat:
                         @"Device State:%02x\r\n"
                         "Device Status: %02x\r\n"
                         "Session State: %02x\r\n"
                         "Device Certificate Status: %02x\r\n"
                         "Hardware Status: %02x\r\n"
                         @"Master and Session Key Status: %02x\r\n",
                         deviceStatus.deviceState,
                         deviceStatus.sessionState,
                         deviceStatus.deviceStatus,
                         deviceStatus.deviceCertificateStatus,
                         deviceStatus.hardwareStatus,
                         deviceStatus.masterSessionKeyStatus
                         ]];
}

- (void)deviceMessageKeyInformation:(Byte)keyID keyStatus:(Byte)keyStatus keyInfo:(NSData *)keyInfo
{
     [self setText:  [NSString stringWithFormat:
                         @"Key Information ID:%02x"
                         "\r\nKey Status: %02x"
                         "\r\nKey Info: %@",
                         keyID,
                         keyStatus,
                         [[NSString alloc] initWithData:keyInfo encoding:NSNonLossyASCIIStringEncoding]
                         ]];
}

- (void)deviceMessageClearTextUserEntry:(Byte)operationStatus clearTextData:(NSData *)clearTextData
{
     [self setText:  [NSString stringWithFormat:
                         @"Clear Text User Entry Operation Status:%02x",
                         operationStatus
                         ]];
    
    if(operationStatus == 0x00)
    {
        //UserDataEntry* entry = [[MTPPSCRA sharedInstance]getUserDataEntry:YES];
        [self setText:  [NSString stringWithFormat: @"User Entry:%@",[HexUtility stringFromHexString: [HexUtility toHex:clearTextData]] ]];
    }
    
}

- (void)deviceMessageUserDataEntry:(Byte)operationStatus
{
     [self setText:  [NSString stringWithFormat:
                         @"User Entry Operation Status:%02x",
                         operationStatus
                         ]];
    
    if(operationStatus == 0x00)
    {
        UserDataEntry* entry = [[MTPPSCRA sharedInstance]getUserDataEntry:YES];
         [self setText:  [NSString stringWithFormat:
                             @"User Entry:%02x"
                             "\r\nKSN:%@"
                             "\r\nData:%@",
                             entry.status,
                             [HexUtility toHex:entry.MSRKSN],
                             [HexUtility toHex:entry.EncryptedUserDataBlock]
                             ]];
    }
}
- (void) deviceMessageKernelInformation:(Byte)kernelID kernelInformation:(NSData*)kernelInformation
{
    [self setText: [NSString stringWithFormat:
                         @"Kernel ID:%02x"
                         "\r\nKernel Information: %@",
                         kernelID,
                         [[NSString alloc] initWithData:kernelInformation encoding:NSNonLossyASCIIStringEncoding]
                         ]];
    
}
- (void)deviceMessageDeviceConfiguration:(NSData *)configData
{
    [self setText:  [NSString stringWithFormat:
                         @"Device Configuration:%@",
                         configData
                         ]];
}

- (void)deviceMessageARQCRequest:(NSData *)ARCQData
{

    NSString* dataString = [HexUtility toHex:ARCQData];
    
    NSMutableDictionary* tlv = [ARCQData parseTLVData];
    
    NSLog(@"%@", [tlv dumpTags]);
    
   
    dispatch_async(dispatch_get_main_queue(), ^{
        
        [self setText:  [NSString stringWithFormat:@"%@ \r\n %@", [NSString stringWithFormat:@"\n[ARQC Received]\n%@", dataString], [tlv dumpTags]]];
        
        if(tlv != nil)
        {
            if(isQuickDip)
            {
                [self setText: @"QuickDip Mode - Will not send respond"];
                return;
            }
            
          [self setText: [NSString stringWithFormat:@"\nSN Bytes = %@", [(MTTLVObject*)[tlv objectForKey:@"DFDF25"] value]]];
            
            NSData*  response = [self buildAcquirerResponse:[HexUtility getBytesFromHexString:[(MTTLVObject*)[tlv objectForKey:@"DFDF25"] value]] encryptionType:[HexUtility getBytesFromHexString:[(MTTLVObject*)[tlv objectForKey:@"DFDF55"] value]] ksn:[HexUtility getBytesFromHexString:[(MTTLVObject*)[tlv objectForKey:@"DFDF54"] value]] approved:YES];

            [[MTPPSCRA sharedInstance]sendAcquirerResponse:response];
            
        }
        
        
    });
    
}


- (NSString*) getTransStatusMsg:(NSString*)codeIn
{
    
    if([codeIn isEqualToString:@"00"]) return @"Accept";
    if([codeIn isEqualToString:@"01"]) return @"Decline";
    if([codeIn isEqualToString:@"02"]) return @"Error";
    if([codeIn isEqualToString:@"10"]) return @"Cancelled by Host";
    if([codeIn isEqualToString:@"11"]) return @"Confirm Amount No";
    if([codeIn isEqualToString:@"12"]) return @"Confirm Amount Timeout";
    if([codeIn isEqualToString:@"13"]) return @"Confirm Amount Cancel";
    if([codeIn isEqualToString:@"14"]) return @"MSR Select Credit";
    if([codeIn isEqualToString:@"15"]) return @"MSR Select Debit";
    if([codeIn isEqualToString:@"16"]) return @"MSR Select Credit/Debit timeout";
    if([codeIn isEqualToString:@"17"]) return @"MSR Select Credit/Debit cancel";
    if([codeIn isEqualToString:@"1B"]) return @"PIN entry Cancelled by Host";
    if([codeIn isEqualToString:@"1C"]) return @"PIN entry timeout";
    if([codeIn isEqualToString:@"1D"]) return @"PIN entry Cancelled by User";
    if([codeIn isEqualToString:@"1E"]) return @"Manual Selection Cancelled by Host";
    if([codeIn isEqualToString:@"1F"]) return @"Manual Selection timeout";
    if([codeIn isEqualToString:@"20"]) return @"Manual Selection Cancelled by User";
    if([codeIn isEqualToString:@"21"]) return @"Waiting For Card Cancelled by Host";
    if([codeIn isEqualToString:@"22"]) return @"Waiting For Card timeout";
    if([codeIn isEqualToString:@"23"]) return @"Waiting For Card Cancelled by User";
    if([codeIn isEqualToString:@"FF"]) return @"Unknown";
    return @"";
}

- (void)deviceMessageEMVData:(NSData *)emvData
{
    //NSString* dataString = [HexUtility toHex:emvData];
    
    //NSData *emvBytes = [HexUtility getBytesFromHexString:dataString];
    NSMutableDictionary* tlv = [emvData parseTLVData];
    dispatch_async(dispatch_get_main_queue(), ^{
         [self setText:   [NSString stringWithFormat:@"\n[Transaction Status]\n%@", [self getTransStatusMsg: [(MTTLVObject*)[tlv objectForKey:@"DFDF1A"] value]]]];
         [self setText: [NSString stringWithFormat:@"\n[Transaction Result Data]\n%@", [tlv dumpTags]]];

    });
    
    if([[tlv allKeys]containsObject:@"DFDF3E"])
    {
        NSString* signData = [(MTTLVObject*)[tlv objectForKey:@"DFDF3E"]value];
        
        [self drawSig:signData];
    }
    //[[MTPPSCRA sharedInstance]endSession:1];
}
-(void)drawSig:(NSString*)sigData
{
    NSData* sig = [HexUtility getBytesFromHexString:sigData];
    MTSigController* sigCon = [[MTSigController alloc]initWithSignature:sig];
    dispatch_async(dispatch_get_main_queue(), ^{
        [self.navigationController pushViewController:sigCon animated:YES];
    });
}

- (NSData*) buildAcquirerResponse:(NSData*)deviceSN encryptionType:(NSData*)encryptionType ksn:(NSData*)ksn approved:(BOOL)approved
{
    
    NSMutableData* response = [[NSMutableData alloc]init];
    
    
    NSInteger lenSN = 0;
    if (deviceSN != nil)
    {
        lenSN = deviceSN.length;
    }
    
    
    Byte snTagByte[] = {(Byte)0xDF, (Byte)0xDF, 0x25, (Byte)lenSN};
    NSData* snTag = [NSData dataWithBytes:snTagByte length:4];
    
    Byte encryptionTypeTagByte[] = {(Byte)0xDF, (Byte)0xDF, 0x55, (Byte)encryptionType.length};
    NSData* encryptionTypeTag = [NSData dataWithBytes:encryptionTypeTagByte length:4];
    
    Byte ksnTagByte[] = {(Byte)0xDF, (Byte)0xDF, 0x54, (Byte)ksn.length};
    NSData* ksnTag = [NSData dataWithBytes:ksnTagByte length:4];
    
    Byte containerByte[] = { (Byte) 0xFA, 0x82, 0x00, 0x06, 0x70, 0x04};
    NSData* container = [NSData dataWithBytes:containerByte length:6];
    
    
    
    
    Byte approvedARCByte[] =  { (Byte) 0x8A, 0x02, 0x30, 0x30, };
    NSData* approvedARC = [NSData dataWithBytes:approvedARCByte length:4];
    
    Byte declinedARCByte[] = { (Byte) 0x8A, 0x02, 0x30, 0x35 };
    NSData* declinedARC = [NSData dataWithBytes:declinedARCByte length:4];
    
    unsigned long totalLen = snTag.length + lenSN + container.length + approvedARC.length + encryptionTypeTag.length + encryptionType.length + ksnTag.length + ksn.length;
    
    Byte len1 = (Byte)((totalLen >>8) & 0xff);
    Byte len2 = (Byte)(totalLen & 0xff);
    
    Byte tempByte[] = {0xf9, 0x82};
    
    [response appendBytes:&tempByte length:2];
    [response appendBytes:&len1 length:1];
    [response appendBytes:&len2 length:1];
    
    
    
    [response appendData:ksnTag];
    [response appendData:ksn];
    
    [response appendData:encryptionTypeTag];
    [response appendData:encryptionType];
    
    [response appendData:snTag];
    [response appendData:deviceSN];
    [response appendData:container];
    
    
    if(approved)
    {
        [response appendData:approvedARC];
    }
    else
    {
        [response appendData:declinedARC];
    }
    
    unsigned long len = response.length;
    len1 = (Byte)((len >>8) & 0xff);;
    len2 = (Byte)(len & 0xff);
    
    NSMutableData* finalResponse = [[NSMutableData alloc]init];
    [finalResponse appendBytes:&len1 length:1];
    [finalResponse appendBytes:&len2 length:1];
    [finalResponse appendData:response];
    int pad = finalResponse.length % 16;
    if(pad > 0)
    {
        [finalResponse increaseLengthBy:(16- pad)];
    }
    
    
    
    NSString* mac = @"00000000";// [MTSOAP calculateMAC:[HexUtility toHex:ksn] data:[HexUtility toHex:finalResponse]type:@"1" derivedData:@""];
    NSData* macData = [HexUtility getBytesFromHexString:[mac substringToIndex:8]];
    
    
    
    [finalResponse appendData:macData];
    //response re
    return  finalResponse;
    
}

@end
