//
//  MTServerListenerViewController.m
//  MTPPSCRASample
//
//  Created by Tam Nguyen on 4/19/17.
//  Copyright © 2017 MagTek. All rights reserved.
//

#import "MTServerListenerViewController.h"
#include <CoreFoundation/CoreFoundation.h>
//#include <sys/socket.h>
//#include <netinet/in.h>
//#define kStreamBufferSize 1024

#import "HexUtility.h"

@interface MTServerListenerViewController ()
{
   // MTSession* session;
    //TransactionMode transMode;
}
@property (strong, nonatomic) NSMutableArray* sessionArray;
@end

@implementation MTServerListenerViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
}


- (void)setUpUI
{
    self.title = @"TCP Server";
    self.navigationItem.rightBarButtonItem = [[UIBarButtonItem alloc] initWithTitle:@"Clear Data"
                                                                              style:UIBarButtonItemStylePlain
                                                                             target:self action:@selector(clearData)];
    
    self.btnConnect = [[UIButton alloc]initWithFrame:CGRectMake(0, self.view.frame.size.height - 98 - 65, self.view.frame.size.width, 50)];
    [self.btnConnect setTitle:@"Start Server" forState:UIControlStateNormal];
    [self.btnConnect setBackgroundColor:UIColorFromRGB(0x3465AA)];
    [self.btnConnect addTarget:self action:@selector(startSession) forControlEvents:UIControlEventTouchUpInside];
    
    
    self.txtData = [[UITextView alloc]initWithFrame:CGRectMake(5, 60, self.view.frame.size.width - 10, self.view.frame.size.height - 240)];
    self.txtData.backgroundColor = UIColorFromRGB(0x667788);
    self.txtData.textColor = UIColorFromRGB(0xffffff);
    [self.txtData setEditable:NO];
    
    
    [self.view addSubview:self.txtData];
    
    [self.view addSubview:self.btnConnect];
    
    [self setText: [NSString stringWithFormat:@"App Version: %@.%@ , SDK Version: %@", [[[NSBundle mainBundle] infoDictionary] objectForKey:@"CFBundleShortVersionString"], [[[NSBundle mainBundle] infoDictionary] objectForKey:@"CFBundleVersion"],   [[MTPPSCRA sharedInstance] getSDKVersion]]];
    
    
    self.txtData.frame = CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height - 160);

    
}



- (void)startSession
{
//    if(session)
//    {
//        if([session getCurrentState] != Disconnected)
//        {
//            [session stopListening];
//            return;
//
//        }
//    }
    if(self.sessionArray.count > 0)
    {
     
        for(MTSession* curSession in self.sessionArray)
        {
            [curSession stopListening];
            [self.btnConnect setTitle: @"Connect" forState:UIControlStateNormal];
            [self.btnConnect setBackgroundColor:UIColorFromRGB(0x3465AA)];
            [self.sessionArray removeObject:curSession];
        }
        return;
    }
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Mode"
                                                    message:@"Please Choose a Mode"
                                                   delegate:self
                                          cancelButtonTitle:@"Cancel"
                                          otherButtonTitles:@"Retail", @"Restaurant", nil];
   // alert.alertViewStyle = UIAlertViewStylePlainTextInput;
    //[[alert textFieldAtIndex:0] setKeyboardType:UIKeyboardTypeDecimalPad];
    //alert.tag = 0;
    [alert show];
    
   // [session startListening];
}


- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex {
    if(!self.sessionArray)
        self.sessionArray = [[NSMutableArray alloc]init];
    MTSession* session;
    if(buttonIndex == 1)
    {
        session = [[MTSession alloc]initWithMode:Retail];
        session.delegate = self;
        [session startListening];
        //transMode = Retail;
    }
    else if (buttonIndex == 2)
    {
        session = [[MTSession alloc]initWithMode:Restaurant];
        session.delegate = self;
        [session startListening];
        //transMode = Restaurant;
    }
    else if (buttonIndex == 0)
    {
        return;
    }
    [self.sessionArray addObject:session];
}
- (void)clearData
{
    self.txtData.text = @"";
}

//- (void) logConsole:(NSString*)data
//{
//    self.txtData.text = [NSString stringWithFormat:@"%@\r%@", self.txtData.text, data];
//}



- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


- (void)sessionDidStart:(id)session
{
      dispatch_async(dispatch_get_main_queue(), ^{
     [self setText: @"Session Started..."];
    [self.btnConnect setTitle:@"Stop" forState:UIControlStateNormal];
    [self.btnConnect setBackgroundColor:UIColorFromRGB(0xcc3333)];
      });
}


- (void)didGetClearText:(NSString *)clearText
{
    [self setText:[NSString stringWithFormat:@"%@%@",  @"Did Get Clear Text: ", clearText]];
}
-(void)requestDisplay:(NSString *)text
{
     [self setText: [NSString stringWithFormat:@"\r%@", text]];
}
/*
 #pragma mark - Navigation
 
 // In a storyboard-based application, you will often want to do a little preparation before navigation
 - (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
 // Get the new view controller using [segue destinationViewController].
 // Pass the selected object to the new view controller.
 }
 */

@end
