//
//  MTSigView.m
//  MTPPSCRASampleV2
//
//  Created by Tam Nguyen on 3/9/16.
//  Copyright © 2016 None. All rights reserved.
//

#import "MTSigView.h"

@implementation MTSigView

-(id)initWithFrameAndSig:(CGRect)rect sig:(NSData*)sig
{
    self = [super initWithFrame:rect];
    self.backgroundColor = [UIColor whiteColor];
    if(self)
    {
        _sigData = [sig copy];
    }
    return self;
}


- (void)drawRect:(CGRect)rect {
    CGContextRef context = UIGraphicsGetCurrentContext();
    CGContextSetLineWidth(context, 2.0);
    CGContextSetStrokeColorWithColor(context, [UIColor blackColor].CGColor);

    
    NSUInteger len = [_sigData length];
    Byte *byteData = (Byte*)malloc(len);
    memcpy(byteData, [_sigData bytes], len);
    
    
    CGPoint oldPoint = CGPointMake((int)byteData[0], (int)byteData[1]);
    int p = 2;
    while (p<len) {
        CGPoint newPoint = CGPointMake((int)byteData[p], (int)byteData[p + 1]);
        if ((newPoint.y != 0xFF) && (oldPoint.y != 0xFF))
        {
            CGContextMoveToPoint(context, oldPoint.x, oldPoint.y);
            CGContextAddLineToPoint(context, newPoint.x, newPoint.y);

            CGContextStrokePath(context);
        }
        oldPoint = newPoint;
        p += 2;
        
    }
    
}


@end
