//
//  HexUtil.m
//  HexUtil
//
//  Created by Tam Nguyen on 5/5/15.
//  Copyright (c) 2015 MagTek. All rights reserved.
//

#import "HexUtility.h"


@implementation HexUtility {


}


+ (NSString *)toHex:(NSData *)aData {
    return [HexUtility toHex:aData offset:0 len:aData.length];
}

+ (NSData *)getBytesFromHexString:(NSString*)strIn
{
    const char *chars = [strIn UTF8String];
    int i = 0;
    NSInteger len = strIn.length;
    
    NSMutableData *data = [NSMutableData dataWithCapacity:len / 2];
    char byteChars[3] = {'\0','\0','\0'};
    unsigned long wholeByte;
    
    while (i < len) {
        byteChars[0] = chars[i++];
        byteChars[1] = chars[i++];
        wholeByte = strtoul(byteChars, NULL, 16);
        [data appendBytes:&wholeByte length:1];
    }
    
    return data;
}


+ (NSString *)toHex:(NSData *)aData offset:(uint)aOffset len:(NSUInteger)aLen {
    NSMutableString *sb = [[NSMutableString alloc] initWithCapacity:aData.length*2];
    uint8_t const *bytes = aData.bytes;
    NSUInteger max = aOffset+aLen;
    for(NSUInteger i=aOffset; i < max; i++) {
        uint8_t b = bytes[i];
        [sb appendFormat:@"%02X", b];
    }
    return sb;
}

+ (NSString *)stringFromHexString:(NSString *)hexString {
    
    
    if (([hexString length] % 2) != 0)
        return nil;
    
    NSMutableString *string = [NSMutableString string];
    
    for (NSInteger i = 0; i < [hexString length]; i += 2) {
        
        NSString *hex = [hexString substringWithRange:NSMakeRange(i, 2)];
        unsigned int decimalValue = 0;
        sscanf([hex UTF8String], "%x", &decimalValue);
        [string appendFormat:@"%c", decimalValue];
        
    }
    
    
    return string;
}

@end