//
//  emvControllerTCP.m
//  MTPPSCRASample
//
//  Created by Tam Nguyen on 6/14/16.
//  Copyright © 2016 MagTek. All rights reserved.
//

#import "emvControllerTCP.h"

@implementation emvControllerTCP
- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.title = @"TCP";
    
    
    [self.btnConnect removeTarget:nil action:NULL forControlEvents:UIControlEventTouchUpInside];
    
    [self.btnConnect addTarget:self action:@selector(connectToDevice) forControlEvents:UIControlEventTouchUpInside];
    
    
    [MTPPSCRA sharedInstance].delegate = self;
    
    
    
}

- (void)connectToDevice
{
    if(![[MTPPSCRA sharedInstance]isDeviceConnected])
    {
        if(NSClassFromString(@"UIAlertController")) {
            
            UIAlertController *alertController = [UIAlertController
                                                  alertControllerWithTitle:@"IP Address"
                                                  message:@"IP Address to connect to"
                                                  preferredStyle:UIAlertControllerStyleAlert];
            
            
            [alertController addTextFieldWithConfigurationHandler:^(UITextField *textField)
             {
                 textField.placeholder = @"IP Address";
                 if([[NSUserDefaults standardUserDefaults] valueForKey:@"ipAddress"])
                 {
                     textField.text = [[NSUserDefaults standardUserDefaults] valueForKey:@"ipAddress"];
                 }
             }];
            UIAlertAction *cancelAction = [UIAlertAction
                                           actionWithTitle:NSLocalizedString(@"Cancel", @"Cancel action")
                                           style:UIAlertActionStyleDestructive
                                           handler:^(UIAlertAction *action)
                                           {
                                               
                                           }];
            UIAlertAction *okAction = [UIAlertAction
                                       actionWithTitle:@"Connect"
                                       style:UIAlertActionStyleDefault
                                       handler:^(UIAlertAction *action)
                                       {
                                           UITextField *txtIP = alertController.textFields.firstObject;
                                           
                                           [[MTPPSCRA sharedInstance] setConnectionType:Net];
                                           [[MTPPSCRA sharedInstance] setAddress:txtIP.text];
                                           [[MTPPSCRA sharedInstance] openDevice];
                                           
                                           NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
                                           [defaults setObject:txtIP.text forKey:@"ipAddress"];
                                           [defaults synchronize];
                                       }];
            UIAlertAction *okActionTLS = [UIAlertAction
                                          actionWithTitle:@"Connect Using TLS"
                                          style:UIAlertActionStyleDefault
                                          handler:^(UIAlertAction *action)
                                          {
                                              UITextField *txtIP = alertController.textFields.firstObject;
                                              
                                              [[MTPPSCRA sharedInstance] setConnectionType:Net_TLS12];
                                              
                                              NSString *identityPath = [[NSBundle mainBundle] pathForResource:@"CertName" ofType:@"p12"];
                                              NSData *PKCS12Data = [NSData dataWithContentsOfFile:identityPath];
                                              
                                              

                                              
                                              [[MTPPSCRA sharedInstance]loadClientCertificate:@"p12" data:PKCS12Data password:@"CertPassword"];
                                             
                                              [MTPPSCRA sharedInstance].delegate = self;
                                              [[MTPPSCRA sharedInstance] setAddress:txtIP.text];
                                              [[MTPPSCRA sharedInstance] openDevice];
                                              
                                              NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
                                              [defaults setObject:txtIP.text forKey:@"ipAddress"];
                                              [defaults synchronize];
                                          }];
            UIAlertAction *okActionTLSTrustAll = [UIAlertAction
                                          actionWithTitle:@"Connect Using TLS - Trust all Root"
                                          style:UIAlertActionStyleDefault
                                          handler:^(UIAlertAction *action)
                                          {
                                              UITextField *txtIP = alertController.textFields.firstObject;
                                              
                                              [[MTPPSCRA sharedInstance] setConnectionType:Net_TLS12_Trust_All];
                                              
                                              NSString *identityPath = [[NSBundle mainBundle] pathForResource:@"CertName" ofType:@"p12"];
                                              NSData *PKCS12Data = [NSData dataWithContentsOfFile:identityPath];
                                              [[MTPPSCRA sharedInstance]loadClientCertificate:@"p12" data:PKCS12Data password:@"CertPassword"];
                                             
                                               [MTPPSCRA sharedInstance].delegate = self;
                                              [[MTPPSCRA sharedInstance] setAddress:txtIP.text];
                                              [[MTPPSCRA sharedInstance] openDevice];
                                              
                                              NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
                                              [defaults setObject:txtIP.text forKey:@"ipAddress"];
                                              [defaults synchronize];
                                          }];
            
            UIAlertAction *startListening = [UIAlertAction
                                             actionWithTitle:@"Listening Mode"
                                             style:UIAlertActionStyleDefault
                                             handler:^(UIAlertAction *action)
                                             {
                                                 if(!sessionArray)
                                                 {
                                                     sessionArray = [[NSMutableArray alloc]init];
                                                 }
                                                     MTSession* session;
                                                     session = [[MTSession alloc]init];
                                                     session.delegate = self;
                                                     [session startListening];
                                                     [sessionArray addObject:session];
                                                 //}
                                             }];
            UIAlertAction *startListeningTrust = [UIAlertAction
                                             actionWithTitle:@"Listening Mode - Trust all Root"
                                             style:UIAlertActionStyleDefault
                                             handler:^(UIAlertAction *action)
                                             {
                                                 if(!sessionArray)
                                                 {
                                                     sessionArray = [[NSMutableArray alloc]init];
                                                 }
                                                     MTSession* session;
                                                     session = [[MTSession alloc]init];
                                                     session.delegate = self;
                                                     session.shouldTrustAll = YES;
                                                     [session startListening];
                                                     [sessionArray addObject:session];
                                                 //}
                                             }];
            
            
            
            [alertController addAction:okAction];
            [alertController addAction:okActionTLS];
            [alertController addAction:okActionTLSTrustAll];
            [alertController addAction:startListening];
              [alertController addAction:startListeningTrust];
            [alertController addAction:cancelAction];
            [self presentViewController:alertController animated:YES completion:nil];
            
            
            
        }
    }
    else
    {
        [[MTPPSCRA sharedInstance]closeDevice];
    }
}


-(void)didGetNewConnection:(NSString *)ipAddress shouldTrustAll:(BOOL)shouldTrustAll useTLS:(BOOL)useTLS
{
    dispatch_async(dispatch_get_main_queue(), ^{
        [self setText:  [NSString stringWithFormat:@"\rGot connection at: %@", ipAddress] ];
     
        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, 2 * NSEC_PER_SEC), dispatch_get_main_queue(), ^{
            
            
            // [self logConsole: [NSString stringWithFormat:@"Opening : %@",  ipAddress] color:[NSColor blackColor]];
            NSString *identityPath = [[NSBundle mainBundle] pathForResource:@"CertName" ofType:@"p12"];
            NSData *PKCS12Data = [NSData dataWithContentsOfFile:identityPath];
            [MTPPSCRA sharedInstance].delegate = self;
            [[MTPPSCRA sharedInstance] loadClientCertificate:@"p12" data:PKCS12Data password:@"CertPassword"];
            
          
            if(!shouldTrustAll && useTLS)
            {
                 //[[MTPPSCRA sharedInstance] loadCertificateChain:[self getCertChain]];
                [[MTPPSCRA sharedInstance] setConnectionType:Net_TLS12];
            }
            else if(shouldTrustAll && useTLS)
            {
                [[MTPPSCRA sharedInstance] setConnectionType:Net_TLS12_Trust_All];
            }
            else if (!useTLS)
            {
                [[MTPPSCRA sharedInstance] setConnectionType:Net];
            }
            [[MTPPSCRA sharedInstance] setAddress:ipAddress];
            [[MTPPSCRA sharedInstance] openDevice];
            
        });
    });
}

- (void)sessionDidStart:(id)session
{
    dispatch_async(dispatch_get_main_queue(), ^{
      [self setText:  @"\rSession Started..."];
    });
    
    
}

-(void) onConnectionStateChanged:(ConnectionType)connectionType state:(ConnectionState)state
{
    [super onConnectionStateChanged:connectionType state:state];
}

- (void)onCertificateError:(NSError *)error
{
    [self setText:  [NSString stringWithFormat: @"\rCertificate Error - %@", error.localizedDescription]];
}
-(void)viewDidAppear:(BOOL)animated
{
    [MTPPSCRA sharedInstance].delegate = self;
}



@end
