//
//  MTSession.h
//  MTPPSCRASample
//
//  Created by Tam Nguyen on 8/29/17.
//  Copyright © 2017 MagTek. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "MTPPSCRA.h"
#import "MTSocketServer.h"
#import "MTSocket.h"

typedef enum {
    Restaurant,
    Retail
}TransactionMode;




@protocol MTSessionEvent <NSObject>
@optional
-(void)sessionStateDidChange:(ConnectionState)state instance:(id)instance;
-(void)sessionDidStart:(id)session;
-(void)didGetClearText:(NSString*)clearText;
-(void)requestDisplay:(NSString*)text;

- (void)didGetNewConnection:(NSString*)ipAddress shouldTrustAll:(BOOL)shouldTrustAll useTLS:(BOOL)useTLS;

@end

@interface MTSession : NSObject<MTPPSCRADelegate>
{
   // MTPPSCRA* ppSCRA;
   // ConnectionState currentState;

    NSString* ipAddress;
    BOOL tlsEnabled;
    //int sockfd, newsockfd, clilen;
    MTSocketServer * server ;
}
-(id)initWithMode:(TransactionMode)mode;
@property (nonatomic, strong) id <MTSessionEvent> delegate;
@property (nonatomic, strong) MTPPSCRA* ppSCRA;
@property (nonatomic) BOOL shouldTrustAll;
- (void)startListening;
- (void)stopListening;

//- (ConnectionState)getCurrentState;
@end
