//
//  MTSocketServer.h
//  MTPPSCRASample
//
//  Created by Tam Nguyen on 8/29/17.
//  Copyright © 2017 MagTek. All rights reserved.
//

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h> 
#include <sys/types.h>
#include <stdlib.h>
#include <unistd.h>

#import <Foundation/Foundation.h>
//#import "MTSocketServer.h"
#import "MTSocket.h"

typedef enum {
	MTSocketServerStateUnopened,
	MTSocketServerStateListening,
	MTSocketServerStateClosed
} MTSocketServerState;

@interface MTSocketServer : NSObject {
    int _fileDescriptor;
	int _port;
	MTSocketServerState state;
}

/**
 * Create a socket server that will listen
 * on a TCP port.
 * @param port The TCP port number to listen on.
 * this must be from 1 to 65535.
 * @return A new TCP socket server.
 */
- (id)initListeningOnPort:(int)port;

/**
 * Get the port on which the server socket is listening.
 * @return The port number of the server socket.
 */
- (int)listeningPort;
- (MTSocket *)acceptConnection;
/**
 * Checks if the socket is listening.
 * @return YES if the socket is listening, NO otherwise.
 */
- (BOOL)isListening;
- (int)listen ;
- (void)stopServer;
@end
